---
# containerd Registry Configuration
# Containerd can be configured to connect to private registries and use them to
#   pull private images on each node.
# Examples of config can be found here:
#   https://docs.rke2.io/install/containerd_registry_configuration/

{% if kubernetes_rke2_containerd_mirrors | length > 0 %}
mirrors:
{% for mirror in kubernetes_rke2_containerd_mirrors %}
  {{ mirror['repository'] }}:
    endpoint:
      - "{{ mirror['mirror'] }}"
{% endfor %}
{% endif %}

{% if kubernetes_rke2_containerd_repository_configs | length > 0 %}
configs:
{% for config in kubernetes_rke2_containerd_repository_configs %}
  "{{ config['repository'] }}":
{% if config['auth'] is defined %}
    auth:
      username: {{ config['auth']['username'] }}
      password: {{ config['auth']['password'] }}
{% endif %}
{% if config['tls'] is defined %}
    tls:
{% if config['tls']['ca_file'] is defined %}
      ca_file: {{ config['tls']['ca_file'] }}
{% endif %}
{% if config['tls']['key_file'] is defined %}
      key_file: {{ config['tls']['key_file'] }}
{% endif %}
{% if config['tls']['cert_file'] is defined %}
      cert_file: {{ config['tls']['cert_file'] }}
{% endif %}
{% if config['tls']['insecure_skip_verify'] is defined %}
      insecure_skip_verify: {{ config['tls']['insecure_skip_verify'] }}
{% endif %}
{% endif %}
{% endfor %}
{% endif %}

{% if kubernetes_rke2_containerd_raw_config is defined  and kubernetes_rke2_containerd_raw_config|length > 0 %}
{{ kubernetes_rke2_containerd_raw_config | to_nice_yaml(indent=2) }}
{% endif %}
